import { Extension } from 'expect';
import { Spy } from 'expect';
declare const CALL_SIGNATURE_KEY: symbol;
declare const SPY_KEY: symbol;
declare const VALUE_KEY: symbol;
interface INewable<T> {
    new (...args: Array<any>): T;
}
declare class Mock<T> {
    private target;
    private nameGenerator;
    mock: T;
    constructor(target: INewable<T>, exclude?: Array<string>);
    spyOn(keyGen: {
        (x: T): any;
    }): Spy;
    private getSpy(targetKey);
    static of<U>(target: INewable<U>, exclude?: Array<string>): Mock<U>;
}
declare const expectExtensions: Extension;
declare function getPropertyNames(target: Object): Array<string>;
declare function isFunction(functionToCheck: Function): boolean;
declare const MATCHER: {
    ANY: symbol;
    NUMBER: symbol;
    STRING: symbol;
    OBJECT: symbol;
    ARRAY: symbol;
};
declare class It {
    static isAny(): any;
    static isString(): any;
    static isArray(): any;
    static isNumber(): any;
    static isObject(): any;
}
export { Mock } 
export { It } 
export { expectExtensions } 